3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
40 # The function takes at most 2 arguments. The first argument is the
41 # URL that navigates to the submodule origin repo. When relative, this URL
42 # is relative to the superproject origin URL repo. The second up_path
43 # argument, if specified, is the relative path that navigates
44 # from the submodule working tree to the superproject working tree.
46 # The output of the function is the origin URL of the submodule.
48 # The output will either be an absolute URL or filesystem path (if the
49 # superproject origin URL is an absolute URL or filesystem path,
50 # respectively) or a relative file system path (if the superproject
51 # origin URL is a relative file system path).
53 # When the output is a relative file system path, the path is either
54 # relative to the submodule working tree, if up_path is specified, or to
55 # the superproject working tree otherwise.
56 resolve_relative_url ()
58 remote=$(get_default_remote)
59 remoteurl=$(git config "remote.$remote.url") ||
60 remoteurl=$(pwd) # the repository is its own authoritative upstream
62 remoteurl=${remoteurl%/}
75 remoteurl="./$remoteurl"
86 remoteurl="${remoteurl%/*}"
89 remoteurl="${remoteurl%:*}"
93 if test -z "$is_relative" || test "." = "$remoteurl"
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
113 # Resolve a path to be relative to another path. This is intended for
114 # converting submodule paths when git-submodule is run in a subdirectory
115 # and only handles paths where the directory separator is '/'.
117 # The output is the first argument as a path relative to the second argument,
118 # which defaults to $wt_prefix if it is omitted.
121 local target curdir result
123 curdir=${2-$wt_prefix}
127 while test -n "$curdir"
131 target=${target#"$curdir"/}
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
141 curdir="${curdir%/*}"
145 echo "$result$target"
149 # Get submodule info for registered submodules
150 # $@ = path to limit submodule list
154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
156 git ls-files -z --error-unmatch --stage -- "$@" ||
157 echo "unmatched pathspec exists"
161 my ($null_sha1) = ("0" x 40);
166 if (/^unmatched pathspec/) {
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
175 if (!$unmerged{$path}++) {
176 push @out, "$mode $null_sha1 U\t$path\n";
183 print "#unmatched\n";
192 if test "$1" = "#unmatched"
199 # Print a submodule configuration setting
201 # $1 = submodule name
205 # Checks in the usual git-config places first (for overrides),
206 # otherwise it falls back on .gitmodules. This allows you to
207 # distribute project-wide defaults in .gitmodules, while still
208 # customizing individual repositories if necessary. If the option is
209 # not in .gitmodules either, print a default value.
211 get_submodule_config () {
215 value=$(git config submodule."$name"."$option")
218 value=$(git config -f .gitmodules submodule."$name"."$option")
220 printf '%s' "${value:-$default}"
225 # Map submodule path to submodule name
231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
244 # Prior to calling, cmd_update checks that a possibly existing
245 # path is not a git repository.
246 # Likewise, cmd_add checks that path does not exist at all,
247 # since it is the location of a new submodule.
257 if test -n "$GIT_QUIET"
264 base_name=$(dirname "$name")
266 gitdir=$(git rev-parse --git-dir)
267 gitdir_base="$gitdir/modules/$base_name"
268 gitdir="$gitdir/modules/$name"
273 rm -f "$gitdir/index"
275 mkdir -p "$gitdir_base"
278 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
279 --separate-git-dir "$gitdir" "$url" "$sm_path"
281 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
284 # We already are at the root of the work tree but cd_to_toplevel will
285 # resolve any symlinks that might be present in $PWD
286 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
287 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
288 # normalize Windows-style absolute paths to POSIX-style absolute paths
289 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
290 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
291 # Remove all common leading directories after a sanity check
292 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
293 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
295 while test "${a%%/*}" = "${b%%/*}"
300 # Now chop off the trailing '/'s that were added in the beginning
304 # Turn each leading "*/" component into "../"
305 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
306 echo "gitdir: $rel/$a" >"$sm_path/.git"
308 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
309 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
314 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
318 # Add a new submodule to the working tree, .gitmodules and the index
322 # optional branch is stored in global branch variable
326 # parse $args after "submodule ... add".
332 case "$2" in '') usage ;; esac
343 case "$2" in '') usage ;; esac
348 reference_path="${1#--reference=}"
351 case "$2" in '') usage ;; esac
356 case "$2" in '') usage ;; esac
377 if test -n "$reference_path"
379 is_absolute_path "$reference_path" ||
380 reference_path="$wt_prefix$reference_path"
382 reference="--reference=$reference_path"
388 if test -z "$sm_path"; then
389 sm_path=$(echo "$repo" |
390 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
393 if test -z "$repo" -o -z "$sm_path"; then
397 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
399 # assure repo is absolute or relative to parent
402 test -z "$wt_prefix" ||
403 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
405 # dereference source url relative to parent's url
406 realrepo=$(resolve_relative_url "$repo") || exit
413 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
418 # multiple //; leading ./; /./; /../; trailing /
419 sm_path=$(printf '%s/\n' "$sm_path" |
429 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
430 die "$(eval_gettext "'\$sm_path' already exists in the index")"
432 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
434 eval_gettextln "The following path is ignored by one of your .gitignore files:
436 Use -f if you really want to add it." >&2
440 if test -n "$custom_name"
442 sm_name="$custom_name"
447 # perhaps the path exists and is already a git repo, else clone it
448 if test -e "$sm_path"
450 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
452 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
454 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
458 if test -d ".git/modules/$sm_name"
462 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
463 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
464 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
465 echo >&2 " $realrepo"
466 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
467 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
469 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
472 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
476 # ash fails to wordsplit ${branch:+-b "$branch"...}
478 '') git checkout -f -q ;;
479 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
481 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
483 git config submodule."$sm_name".url "$realrepo"
485 git add $force "$sm_path" ||
486 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
488 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
489 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
492 git config -f .gitmodules submodule."$sm_name".branch "$branch"
494 git add --force .gitmodules ||
495 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
499 # Execute an arbitrary command sequence in each checked out
502 # $@ = command to execute
506 # parse $args after "submodule ... foreach".
528 # dup stdin so that it can be restored when running the external
529 # command in the subshell (and a recursive call to this function)
533 while read mode sha1 stage sm_path
535 die_if_unmatched "$mode"
536 if test -e "$sm_path"/.git
538 displaypath=$(relative_path "$sm_path")
539 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
540 name=$(module_name "$sm_path")
542 prefix="$prefix$sm_path/"
545 sm_path=$(relative_path "$sm_path") &&
546 # we make $path available to scripts ...
554 if test -n "$recursive"
556 cmd_foreach "--recursive" "$@"
559 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
565 # Register submodules in .git/config
567 # $@ = requested paths (default to all)
571 # parse $args after "submodule ... init".
593 while read mode sha1 stage sm_path
595 die_if_unmatched "$mode"
596 name=$(module_name "$sm_path") || exit
598 displaypath=$(relative_path "$sm_path")
600 # Copy url setting when it is not set yet
601 if test -z "$(git config "submodule.$name.url")"
603 url=$(git config -f .gitmodules submodule."$name".url)
605 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
607 # Possibly a url relative to parent
610 url=$(resolve_relative_url "$url") || exit
613 git config submodule."$name".url "$url" ||
614 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
616 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
619 # Copy "update" setting when it is not set yet
620 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
622 test -z "$(git config submodule."$name".update)"
625 rebase | merge | none)
626 ;; # known modes of updating
628 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
632 git config submodule."$name".update "$upd" ||
633 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
639 # Unregister submodules from .git/config and remove their work tree
641 # $@ = requested paths (use '.' to deinit all submodules)
645 # parse $args after "submodule ... deinit".
671 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
675 while read mode sha1 stage sm_path
677 die_if_unmatched "$mode"
678 name=$(module_name "$sm_path") || exit
680 displaypath=$(relative_path "$sm_path")
682 # Remove the submodule work tree (unless the user already did it)
683 if test -d "$sm_path"
685 # Protect submodules containing a .git directory
686 if test -d "$sm_path/.git"
688 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
689 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
694 git rm -qn "$sm_path" ||
695 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
698 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
699 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
702 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
704 # Remove the .git/config entries (unless the user already did it)
705 if test -n "$(git config --get-regexp submodule."$name\.")"
707 # Remove the whole section so we have a clean state when
708 # the user later decides to init this submodule again
709 url=$(git config submodule."$name".url)
710 git config --remove-section submodule."$name" 2>/dev/null &&
711 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
717 # Update each submodule path to correct revision, using clone and checkout as needed
719 # $@ = requested paths (default to all)
723 # parse $args after "submodule ... update".
746 case "$2" in '') usage ;; esac
747 reference="--reference=$2"
763 case "$2" in '') usage ;; esac
786 cmd_init "--" "$@" || return
792 while read mode sha1 stage sm_path
794 die_if_unmatched "$mode"
797 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
800 name=$(module_name "$sm_path") || exit
801 url=$(git config submodule."$name".url)
802 branch=$(get_submodule_config "$name" branch master)
803 if ! test -z "$update"
805 update_module=$update
807 update_module=$(git config submodule."$name".update)
810 displaypath=$(relative_path "$prefix$sm_path")
812 if test "$update_module" = "none"
814 echo "Skipping submodule '$displaypath'"
820 # Only mention uninitialized submodules when its
821 # path have been specified
823 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
824 Maybe you want to use 'update --init'?")"
828 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
830 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
831 cloned_modules="$cloned_modules;$name"
834 subsha1=$(clear_local_git_env; cd "$sm_path" &&
835 git rev-parse --verify HEAD) ||
836 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
841 if test -z "$nofetch"
843 # Fetch remote before determining tracking $sha1
844 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
845 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
847 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
848 sha1=$(clear_local_git_env; cd "$sm_path" &&
849 git rev-parse --verify "${remote_name}/${branch}") ||
850 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
853 if test "$subsha1" != "$sha1" -o -n "$force"
856 # If we don't already have a -f flag and the submodule has never been checked out
857 if test -z "$subsha1" -a -z "$force"
862 if test -z "$nofetch"
864 # Run fetch only if $sha1 isn't present or it
865 # is not reachable from a ref.
866 (clear_local_git_env; cd "$sm_path" &&
867 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
868 test -z "$rev") || git-fetch)) ||
869 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
872 # Is this something we just cloned?
873 case ";$cloned_modules;" in
875 # then there is no local change to integrate
880 case "$update_module" in
883 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
884 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
885 must_die_on_failure=yes
889 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
890 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
891 must_die_on_failure=yes
894 command="${update_module#!}"
895 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
896 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
897 must_die_on_failure=yes
900 command="git checkout $subforce -q"
901 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
902 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
906 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
909 elif test -n "$must_die_on_failure"
911 die_with_status 2 "$die_msg"
913 err="${err};$die_msg"
918 if test -n "$recursive"
921 prefix="$prefix$sm_path/"
929 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
932 err="${err};$die_msg"
935 die_with_status $res "$die_msg"
962 git describe "$2" 2>/dev/null ||
963 git describe --tags "$2" 2>/dev/null ||
964 git describe --contains "$2" 2>/dev/null ||
965 git describe --all --always "$2"
968 test -z "$revname" || revname=" ($revname)"
971 # Show commit summary for submodules in index or working tree
973 # If '--cached' is given, show summary between index and given commit,
974 # or between working tree and given commit
976 # $@ = [commit (default 'HEAD'),] requested paths (default all)
983 # parse $args after "submodule ... summary".
998 isnumber "$summary_limit" || usage
1002 summary_limit="${1#--summary-limit=}"
1003 isnumber "$summary_limit" || usage
1019 test $summary_limit = 0 && return
1021 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
1024 test $# = 0 || shift
1025 elif test -z "$1" -o "$1" = "HEAD"
1027 # before the first commit: compare with an empty tree
1028 head=$(git hash-object -w -t tree --stdin </dev/null)
1029 test -z "$1" || shift
1036 test -n "$cached" &&
1037 die "$(gettext "The --cached option cannot be used with the --files option")"
1043 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
1044 # Get modified modules cared by user
1045 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
1046 sane_egrep '^:([0-7]* )?160000' |
1047 while read mod_src mod_dst sha1_src sha1_dst status sm_path
1049 # Always show modules deleted or type-changed (blob<->module)
1050 test $status = D -o $status = T && echo "$sm_path" && continue
1051 # Respect the ignore setting for --for-status.
1052 if test -n "$for_status"
1054 name=$(module_name "$sm_path")
1055 ignore_config=$(get_submodule_config "$name" ignore none)
1056 test $status != A -a $ignore_config = all && continue
1058 # Also show added or modified modules which are checked out
1059 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1064 test -z "$modules" && return
1066 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
1067 sane_egrep '^:([0-7]* )?160000' |
1069 while read mod_src mod_dst sha1_src sha1_dst status name
1071 if test -z "$cached" &&
1072 test $sha1_dst = 0000000000000000000000000000000000000000
1076 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1078 100644 | 100755 | 120000)
1079 sha1_dst=$(git hash-object $name)
1085 eval_gettextln "unexpected mode \$mod_dst" >&2
1092 test $mod_src = 160000 &&
1093 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1096 test $mod_dst = 160000 &&
1097 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1100 display_name=$(relative_path "$name")
1103 case "$missing_src,$missing_dst" in
1105 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1108 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1111 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1116 if test $mod_src = 160000 -a $mod_dst = 160000
1118 range="$sha1_src...$sha1_dst"
1119 elif test $mod_src = 160000
1125 GIT_DIR="$name/.git" \
1126 git rev-list --first-parent $range -- | wc -l
1128 total_commits=" ($(($total_commits + 0)))"
1132 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1133 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1136 blob="$(gettext "blob")"
1137 submodule="$(gettext "submodule")"
1138 if test $mod_dst = 160000
1140 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1142 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1145 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1147 if test -n "$errmsg"
1149 # Don't give error msg for modification whose dst is not submodule
1150 # i.e. deleted or changed to blob
1151 test $mod_dst = 160000 && echo "$errmsg"
1153 if test $mod_src = 160000 -a $mod_dst = 160000
1156 test $summary_limit -gt 0 && limit="-$summary_limit"
1157 GIT_DIR="$name/.git" \
1158 git log $limit --pretty='format: %m %s' \
1159 --first-parent $sha1_src...$sha1_dst
1160 elif test $mod_dst = 160000
1162 GIT_DIR="$name/.git" \
1163 git log --pretty='format: > %s' -1 $sha1_dst
1165 GIT_DIR="$name/.git" \
1166 git log --pretty='format: < %s' -1 $sha1_src
1174 # List all submodules, prefixed with:
1175 # - submodule not initialized
1176 # + different revision checked out
1178 # If --cached was specified the revision in the index will be printed
1179 # instead of the currently checked out revision.
1181 # $@ = requested paths (default to all)
1185 # parse $args after "submodule ... status".
1213 while read mode sha1 stage sm_path
1215 die_if_unmatched "$mode"
1216 name=$(module_name "$sm_path") || exit
1217 url=$(git config submodule."$name".url)
1218 displaypath=$(relative_path "$prefix$sm_path")
1219 if test "$stage" = U
1221 say "U$sha1 $displaypath"
1224 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
1226 say "-$sha1 $displaypath"
1229 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1231 set_name_rev "$sm_path" "$sha1"
1232 say " $sha1 $displaypath$revname"
1234 if test -z "$cached"
1236 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1238 set_name_rev "$sm_path" "$sha1"
1239 say "+$sha1 $displaypath$revname"
1242 if test -n "$recursive"
1245 prefix="$displaypath/"
1250 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1255 # Sync remote urls for submodules
1256 # This makes the value for remote.$remote.url match the value
1257 # specified in .gitmodules.
1286 while read mode sha1 stage sm_path
1288 die_if_unmatched "$mode"
1289 name=$(module_name "$sm_path")
1290 url=$(git config -f .gitmodules --get submodule."$name".url)
1292 # Possibly a url relative to parent
1295 # rewrite foo/bar as ../.. to find path from
1296 # submodule work tree to superproject work tree
1297 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1298 # guarantee a trailing /
1299 up_path=${up_path%/}/ &&
1300 # path from submodule work tree to submodule origin repo
1301 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1302 # path from superproject work tree to submodule origin repo
1303 super_config_url=$(resolve_relative_url "$url") || exit
1306 sub_origin_url="$url"
1307 super_config_url="$url"
1311 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1313 displaypath=$(relative_path "$prefix$sm_path")
1314 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1315 git config submodule."$name".url "$super_config_url"
1317 if test -e "$sm_path"/.git
1322 remote=$(get_default_remote)
1323 git config remote."$remote".url "$sub_origin_url"
1325 if test -n "$recursive"
1327 prefix="$prefix$sm_path/"
1336 # This loop parses the command line arguments to find the
1337 # subcommand name to dispatch. Parsing of the subcommand specific
1338 # options are primarily done by the subcommand implementations.
1339 # Subcommand specific options such as --branch and --cached are
1340 # parsed here as well, for backward compatibility.
1342 while test $# != 0 && test -z "$command"
1345 add | foreach | init | deinit | update | status | summary | sync)
1375 # No command word defaults to "status"
1376 if test -z "$command"
1386 # "-b branch" is accepted only by "add"
1387 if test -n "$branch" && test "$command" != add
1392 # "--cached" is accepted only by "status" and "summary"
1393 if test -n "$cached" && test "$command" != status -a "$command" != summary